package com.moneyhouse.sensors.filetrigger;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;

import org.apache.log4j.Logger;
/**
 * It writes a event file into the from brick folder
 * @since 2014.10.28 
 * @author Frederic
 *
 */
public class FileMonitorFromBrickSingleton {
	private static FileMonitorFromBrickSingleton instance = null;
	private static Logger logger = Logger.getLogger(FileMonitorFromBrickSingleton.class);	
	
	protected FileMonitorFromBrickSingleton(){}
	
	   public static FileMonitorFromBrickSingleton getInstance() {
		      if(instance == null) {
		    	  instance = new FileMonitorFromBrickSingleton();
		      }
		      return instance;
		   }	
	
	
	/**
	 * Create a trigger file in monitored folder
	 * @param filename
	 */
	public synchronized void createFileAsEvent(String pathfilename, String content){
		logger.info("-----> FileMonitorFromBrickSingleton.createFileAsEvent("+pathfilename+", content) INSTANCE = "+ this.hashCode());
		FileOutputStream fop = null;
		File file;
		try {
 
			file = new File(pathfilename);
			fop = new FileOutputStream(file);
 
			// if file doesnt exists, then create it
			if (!file.exists()) {
				file.createNewFile();
			}
 
			// get the content in bytes
			byte[] contentInBytes = content.getBytes();
 
			fop.write(contentInBytes);
			fop.flush();
			fop.close();
 
			logger.info("WRITING FILE ["+pathfilename+"] DONE");
 
		} catch (IOException e) {
			logger.error("ERROR: ERROR OCCURED WHILE WRITING FILE ", e);
			e.printStackTrace();
		} finally {
			try {
				if (fop != null) {
					fop.close();
				}
			} catch (IOException e) {
				logger.error("ERROR: ERROR OCCURED WHILE CLOSING FILE ", e);
				e.printStackTrace();
			}
		}
		logger.info("<----- FileMonitorFromBrickSingleton.createFileAsEvent("+pathfilename+", "+content+")");
		
	}
}
	

