package com.moneyhouse.sensors.json;

import java.io.Serializable;

/**
 * @author Frederic
 * @since 3.11.2014
 * 
 * Data structure should look like this:
 * [{"fromaddress":"n/a","correlid":"33333","timestamp":"n/a","executiontime":"n/a"}]
 * {"correlid":"MnZYZeGr","executiontime":"1896","fromaddress":"0x00,0x13,0xa2,0x00,0x40,0x0a,0x4a,0x0a","timestamp":"2014-11-03 16:38:34.139"}
 * 
 */
abstract public class JSONAbstract implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -7399374489654393736L;
	private String fromaddress = "";
	private String correlid = "";
	private String timestamp = "";
	private String command = "";
	
	public JSONAbstract(){
	}

	public JSONAbstract(String fromaddress, String correlid, String timestamp){
		this.fromaddress = fromaddress;
		this.correlid = correlid;
		this.timestamp = timestamp;
		
	}

	public String getFromaddress() {
		return fromaddress;
	}

	public void setFromaddress(String fromaddress) {
		this.fromaddress = fromaddress;
	}

	public String getCorrelid() {
		return correlid;
	}

	public void setCorrelid(String correlid) {
		this.correlid = correlid;
	}

	public String getTimestamp() {
		return timestamp;
	}

	public void setTimestamp(String timestamp) {
		this.timestamp = timestamp;
	}


	public String getCommand() {
		return command;
	}

	public void setCommand(String command) {
		this.command = command;
	}
	
}