package com.moneyhouse.sensors.json;

import java.io.Serializable;

/**
 * @author Frederic
 * @since 3.11.2014
 * 
 * Data structure should look like this:
 * [{"fromaddress":"n/a","correlid":"33333","timestamp":"n/a","executiontime":"n/a"}]
 * {"correlid":"MnZYZeGr","executiontime":"1896","fromaddress":"0x00,0x13,0xa2,0x00,0x40,0x0a,0x4a,0x0a","timestamp":"2014-11-03 16:38:34.139"}
 * 
 */
public class JSONEvent extends JSONAbstract implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -7399374489654393736L;
	private String portname = "";
	private String portvalue = "";
	private String valuetype = "";
	
	public JSONEvent(){
	}

	/**
	 * @param fromaddress
	 * @param correlid
	 * @param timestamp
	 * @param portname
	 * @param portvalue
	 * @param valtype
	 */
	public JSONEvent(String fromaddress, String correlid, String timestamp, String portname, String portvalue, String valtype){
		this.setFromaddress(fromaddress) ;
		this.setCorrelid(correlid) ;
		this.setTimestamp(timestamp);
		this.portname = portname;
		this.portvalue = portvalue;
		this.valuetype = valtype;
		
	}





	public String getPortname() {
		return portname;
	}

	public void setPortname(String portname) {
		this.portname = portname;
	}

	public String getPortvalue() {
		return portvalue;
	}

	public void setPortvalue(String portvalue) {
		this.portvalue = portvalue;
	}


	public String getValuetype() {
		return valuetype;
	}

	public void setValuetype(String valuetype) {
		this.valuetype = valuetype;
	}
	
}