package com.moneyhouse.sensors.json;

import java.io.Serializable;

/**
 * @author Frederic
 * @since 3.11.2014
 * 
 * Data structure should look like this:
 * [{"fromaddress":"n/a","correlid":"33333","timestamp":"n/a","executiontime":"n/a"}]
 * {"correlid":"MnZYZeGr","executiontime":"1896","fromaddress":"0x00,0x13,0xa2,0x00,0x40,0x0a,0x4a,0x0a","timestamp":"2014-11-03 16:38:34.139"}
 * 
 */
public class JSONPingAnswer extends JSONAbstract implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -7399374489654393736L;
	private String executiontime = "";
	
	public JSONPingAnswer(){
	}

	public JSONPingAnswer(String fromaddress, String correlid, String timestamp, String executiontime){
		this.setFromaddress(fromaddress) ;
		this.setCorrelid(correlid) ;
		this.setTimestamp(timestamp);
		this.executiontime = executiontime;
		
	}

	

	public String getExecutiontime() {
		return executiontime;
	}

	public void setExecutiontime(String executiontime) {
		this.executiontime = executiontime;
	}
}