package com.moneyhouse.sensors.json;

import java.util.ArrayList;

import com.moneyhouse.sensors.xbee.dto.XBeeDataTransportObject;

//import com.moneyhouse.util.global.dto.BricksValueDataObject;
//import com.moneyhouse.util.global.dto.JSONBrickValueDataTimeSeries;

public class TransformDataToJasonFileFormat {

	
	
	
	/**
	 * Creates JSON For Messages coming from XBee
	 * @param List<BricksValueDataObject>
	 * @param BricksDataObject
	 * @return
	 */
	public synchronized static final ArrayList<JSONAbstract> transform(XBeeDataTransportObject data){
		ArrayList<JSONAbstract> retval = new ArrayList<JSONAbstract>();
		String brickid = data.getBrickstuniqueId().replace("0x", "").replace(",", "").trim();	
		
		if(data.getCommand() == null){
			throw new RuntimeException("ERROR: DATA RECEIVED HAS COMMAND == NULL - EXPECTED IS PING SLIST PLIST OR EVENT");
		} 
		else if(data.getCommand().equals("SLIST") || data.getCommand().equals("PLIST") || data.getCommand().equals("PING")){
			JSONPingAnswer ele = new JSONPingAnswer();
			ele.setCorrelid(data.getCorrelid());

			ele.setFromaddress(brickid);
			ele.setCommand(data.getCommand());
			
			// MIGHT need some transforming for better readability
			ele.setTimestamp(data.getCreatedtimestamp().toString());
			ele.setExecutiontime(""+data.getExecutiontime());
			retval.add(ele);
		}
		else if(data.getCommand().equals("EVENT")){
			JSONEvent ele = new JSONEvent();
			ele.setCorrelid(data.getCorrelid());

			ele.setFromaddress(brickid);
			ele.setCommand(data.getCommand());
			
			// MIGHT need some transforming for better readability
			ele.setTimestamp(data.getCreatedtimestamp().toString());
			ele.setPortname(data.getReadingport());
			ele.setPortvalue(data.getReadingvalue());
			ele.setValuetype(data.getReadingtype());
			retval.add(ele);
		}		
		else {
			throw new RuntimeException("ERROR: COMMAND ["+data.getCommand()+"] IS NOT KNOWN - EXPECTED IS EVENT, PLIST, SLIST OR PING");
			
		}
		return retval;
	}	
}
