package com.moneyhouse.sensors.pi.dto;

import java.io.Serializable;
import java.math.BigDecimal;
import java.sql.Timestamp;

/**
 * Holds the result of a one wire sensor connected to the PI / basis station
 * @author Frederic
 * @since 13.07.2015
 */
public class DSSensorResultDO implements Serializable{
	private static final long serialVersionUID = 8807498681241308985L;

	private String sensorID = "";

	private String readingValueStr = "";
	private BigDecimal readingValueBD = null;
	private String crcValue = "";
	private boolean readingValueValid = false;
	private Timestamp readingtime  = null;
	
	
	public DSSensorResultDO(){}
	

	/**
	 * fill in the BigDecimal Value, and sets the valid value to true
	 * @param readingValue
	 */
	public DSSensorResultDO(String readingValue){
		readingValueStr = readingValue;
		readingValueBD = new BigDecimal(readingValue);
		readingValueValid = true;
	}

	
	public String toString(){
		return this.readingValueStr +"\t" + this.readingValueValid+"\t" + this.readingValueBD;
	}

	public String getSensorID() {
		return sensorID;
	}


	public void setSensorID(String sensorID) {
		this.sensorID = sensorID;
	}


	public String getReadingValueStr() {
		return readingValueStr;
	}


	public void setReadingValueStr(String readingValueStr) {
		this.readingValueStr = readingValueStr;
	}


	public BigDecimal getReadingValueBD() {
		return readingValueBD;
	}


	public void setReadingValueBD(BigDecimal readingValueBD) {
		this.readingValueBD = readingValueBD;
	}


	public String getCrcValue() {
		return crcValue;
	}


	public void setCrcValue(String crcValue) {
		this.crcValue = crcValue;
	}


	public boolean isReadingValueValid() {
		return readingValueValid;
	}


	public void setReadingValueValid(boolean readingValueValid) {
		this.readingValueValid = readingValueValid;
	}


	public Timestamp getReadingtime() {
		return readingtime;
	}


	public void setReadingtime(Timestamp readingtime) {
		this.readingtime = readingtime;
	}

	
	
	
	
}
