package com.moneyhouse.sensors.xbee;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;

import org.apache.log4j.Logger;

import com.moneyhouse.sensors.config.PropertiesFileReader;
import com.moneyhouse.sensors.config.ServerEnvironmentSingleton;
import com.moneyhouse.sensors.xbee.dto.XBeeComandObject;
import com.moneyhouse.sensors.xbee.dto.XBeeComandResultObject;
import com.rapplogic.xbee.api.RemoteAtRequest;
import com.rapplogic.xbee.api.RemoteAtResponse;
import com.rapplogic.xbee.api.XBee;
import com.rapplogic.xbee.api.XBeeAddress16;
import com.rapplogic.xbee.api.XBeeAddress64;
import com.rapplogic.xbee.api.XBeeException;
import com.rapplogic.xbee.api.XBeeRequest;
import com.rapplogic.xbee.api.XBeeResponse;
import com.rapplogic.xbee.api.XBeeTimeoutException;
import com.rapplogic.xbee.api.zigbee.ZBForceSampleRequest;
import com.rapplogic.xbee.api.zigbee.ZNetExplicitTxRequest;
import com.rapplogic.xbee.api.zigbee.ZNetRxIoSampleResponse;
import com.rapplogic.xbee.api.zigbee.ZNetTxRequest;
import com.rapplogic.xbee.util.ByteUtils;
import com.rapplogic.xbee.util.DoubleByte;

import flexjson.JSONSerializer;
import flexjson.transformer.DateTransformer;

public class SerialReceiverCommandsNotNeeded {
	private final static Logger logger = Logger.getLogger(SerialReceiverCommandsNotNeeded.class);
	
	
	protected static synchronized String sendConstantFFFE(XBeeComandObject cmd, XBeeComandResultObject result, XBee xbee)  {
		logger.info("-----> sendConstantFFFE()");
//		XBee xbee = XBeeSingleton.getInstance().getXbee();
		String retval = "";
		
		
		// sendIncrementData(cmd, result);
		
		
		
		try {
			
//			openCOMPort(xbee);	
			
			// int[] payload = new int[] { 91, 91 };
			// logger.debug("       payload = { 91, 91 } statt { 90, 180 }");
			
			// specify the remote XBee 16-bit MY address
//			XBeeAddress16 destination = new XBeeAddress16(0x13, 0xdb); // nodeAddress16=0x13,0xdb  nodeAddress64=0x00,0x13,0xa2,0x00,0x40,0x0a,0x42,0xc5 
//			XBeeAddress64 desti = new XBeeAddress64("00 13 a2 00 40 0a 42 c5");
			logger.debug("       DESTINATION: " + cmd.getBrickid());
			
			
//			TxRequest16 tx = new TxRequest16(destination, payload);

//			TxRequest64 tx64 = new TxRequest64(desti, payload);
			
			logger.debug("       START SENDING");
	//		TxStatusResponse status = (TxStatusResponse) xbee.sendSynchronous(tx);
			
			// self made package
//			int [] data = {0x7E, 0x00 , 0x11 , 0x10 , 0x01 , 0x00 , 0x13 , 0xA2 , 0x00 , 0x40 , 0x0A , 0x42 , 0xC5 , 0xFF , 0xFE , 0x00 , 0x00 , 0x4E , 0x4F , 0x44 , 0x0A};

			String data = "0x7E, 0x00 , 0x11 , 0x10 , 0x01 , 0x00 , 0x13 , 0xA2 , 0x00 , 0x40 , 0x0A , 0x42 , 0xC5 , 0xFF , 0xFE , 0x00 , 0x00 , 0x4E , 0x4F , 0x44 , 0x0A";

			int [] tosend = XBeeDataTransmitter.assembleTXRequest(cmd.getBrickid(), "FF FE", data);
			xbee.sendPacket(tosend);
			logger.debug("       END SENDING");

			result.setResponseOK(true);
			result.setResponseValue(retval);
		} catch(Exception e){
			result.setResponseError(true);
			e.printStackTrace();
			logger.error("SOME ERROR: ",e);
		} 
		finally {
			xbee.close();
			logger.info("<----- sendConstantFFFE()");
		}
		return retval;
	}	
	protected static synchronized void cmdAT_GENERIC(String addr, String command, XBeeComandResultObject result, XBee xbee) {
		String finaladdr = transformStringToValid64BitXBeeAddress(addr);
		XBeeAddress64 address = new XBeeAddress64(finaladdr);
		cmdAT_GENERIC(address,command,result, xbee);
	}

	protected static synchronized void cmdAT_GENERIC(XBeeAddress64 address, String command, XBeeComandResultObject result, XBee xbee) {
		logger.info("-----> cmdAT_GENERIC(" + address + ", "+command+")");
		if(command.length() != 2){
			throw new RuntimeException("ERROR: AT COMMAND FOR GENERIC METHOD MUST BE OF LENGTH 2 - BUT IT IS ["+command+"]");
		}
		
		
		
//		XBee xbee = XBeeSingleton.getInstance().getXbee();
		try {
//			openCOMPort(xbee);
			RemoteAtRequest request = new RemoteAtRequest(address, command);
			RemoteAtResponse response = (RemoteAtResponse) xbee.sendSynchronous(request, 10000);
			if (response.isOk()) {
				// success
				logger.info("REQUEST SUCCESSFUL");
				logger.info("REQUEST VALUE " +  response.getValue());
				String sh = ByteUtils.toBase16(response.getValue());
				logger.info("REQUEST VALUE ID BASE 16 " +  sh);
				String sh2 = ByteUtils.toBase10(response.getValue());
				logger.info("REQUEST VALUE ID BASE 10" +  sh2);
				
				String respo = sh + " ---> " + sh2;
				result.setResponseValue(respo);
				result.setResponseOK(true);
			} else if(response.isError()){
				logger.info("REQUEST IS ERROR");
				result.setResponseError(true);
				
			} else{
				logger.info("16 BIT ADDRESS UNKNOWN "+ response.isSixteenBitAddressUnknown());
				result.setResponseValue("SOMETHING WENT WRONG: PLEASE CHECK YOU PARAMETERS - ESP. THE BRICK ADDRESS");
			} 
		} catch(Exception e){
			e.printStackTrace();
			logger.error("ERROR EXECUTING cmdAT_GENERIC: ", e);

		} 
		finally {
			xbee.close();
			logger.info("<----- cmdAT_GENERIC(" + address + ")");
		}
	}
	
	protected static synchronized ArrayList<String> cmdReadPortAD(String addr, String portnumber, XBee xbee) {
		String finaladdr = transformStringToValid64BitXBeeAddress(addr);
		XBeeAddress64 address = new XBeeAddress64(finaladdr);
		int port = new Integer(portnumber).intValue();
		return cmdReadPortAD(address, port, xbee);
	}

	
	/**
	 * Read the ad converter 100 times and returns 100 values 
	 * @param address
	 * @param portnumber
	 * @return
	 */
	protected static synchronized ArrayList<String> cmdReadPortAD(XBeeAddress64 address, int portnumber, XBee xbee) {
		logger.info("-----> readPortAD1_PIN19(" + address + ")");
//		XBee xbee = XBeeSingleton.getInstance().getXbee();
		ArrayList<String> retval = new ArrayList<String>();
		if(portnumber < 0 || portnumber > 3){
			throw new RuntimeException("ERROR: WE ONLY HAVE PORTS 0, 1, 2 and 3. YOU ENTERED PORT ["+portnumber+"] WHICH IS NOT VALID"); 
		}
		
		try {
//			openCOMPort(xbee);
			for (int i = 0; i < 100; i++) {
				// pin 20 corresponds to D0, and 5 activates the output (Digital
				// output high)
				String port = "D"+portnumber;
				
				logger.debug(i + "\t---- Configure Port AD1_PIN19 ----");
				RemoteAtRequest request = new RemoteAtRequest(address, port,  new int[] { 2 });
				RemoteAtResponse response = (RemoteAtResponse) xbee.sendSynchronous(request, 10000);
				if (response.isOk()) {
					// success
					logger.debug(i + "\t--- CALL SAMPLE ---");
					XBeeRequest samplerequest = new ZBForceSampleRequest(address);

					Integer reading = readDataFromPin(xbee, samplerequest);					
					String readingstr = reading.toString();
					retval.add(readingstr);
				} 
				else if(response.isError()){
					logger.info(i + "\t\tResponse is ERROR");
					logger.info(i + "\t\tResponse = "+ response);
					i = i +20;
					retval.add("Response is ERROR: " + response);
					
				} 
				else {
					logger.info(i + "\t\tResponse NOT NOT NOT ok");
					logger.info(i + "\t\tResponse = "+ response);
					i = i +20;
					retval.add("Response NOT NOT NOT OK: " + response);
					
				}
				// pause for 4 seconds
				logger.debug(i + "\t\tpause 1 second");
				Thread.sleep(200);
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		} finally {
			xbee.close();
		}
	
		logger.info("<----- readPortAD1_PIN19(" + address + ")");
		return retval;
	}	
	protected static synchronized String sendIncrementData(XBee xbee, XBeeComandObject cmd, XBeeComandResultObject result, long waittime)  {
		logger.info("-----> sendIncrementData()");
//		XBee xbee = XBeeSingleton.getInstance().getXbee();
		String retval = "";
		result.setCommand(cmd);
		try {
//			openCOMPort(xbee);	
			int[] payload_base = new int[] { 0x30, 0x30 };
			int[] payload = new int[] { 0x30, 0x30 };
			XBeeAddress64 dest64 = new XBeeAddress64(XBeeDataTransmitter.parse64or16BitAddress(cmd.getBrickid()));

			for(int j = 0 ; j < 9; j++){
				for(int ii = 0 ; ii < 43; ii++){
					if(ii >= 10 && ii < 16){
						// jump over :;<=> and continue with A
						ii = 17;
					}
					payload[0] = payload_base[0]+j;
					payload[1] = payload_base[1]+ii;

					ZNetTxRequest req = new ZNetTxRequest(dest64, payload);
					logger.info("PAYLOAD: "+ ByteUtils.toString(payload));
						
					// loopback test
					int sourceEndpoint = 0;
					int destinationEndpoint = ZNetExplicitTxRequest.Endpoint.DATA.getValue();
					
					
					logger.debug("       DESTINATION: " + cmd.getBrickid());
					logger.debug("       START SENDING");

					DoubleByte clusterId = new DoubleByte(0x0, ZNetExplicitTxRequest.ClusterId.SERIAL_LOOPBACK.getValue());
					//DoubleByte clusterId = new DoubleByte(0x0, ZNetExplicitTxRequest.ClusterId.TRANSPARENT_SERIAL.getValue());
					
					// first request we just send 64-bit address.  we get 16-bit network address with status response
					ZNetExplicitTxRequest request = new ZNetExplicitTxRequest(0xff, dest64, XBeeAddress16.ZNET_BROADCAST, 
								ZNetTxRequest.DEFAULT_BROADCAST_RADIUS, ZNetTxRequest.Option.UNICAST, payload, sourceEndpoint, destinationEndpoint, clusterId, ZNetExplicitTxRequest.znetProfileId);
					
					logger.info("sending explicit " + request.toString());
					
					xbee.sendAsynchronous(req);
				
					XBeeResponse response = xbee.getResponse();
					result.setResponseValue("PAYLOAD: "+ ByteUtils.toString(payload)+ "   RESPONSE:" + response.toString());
					result.setResponseOK(true);
					
					logger.info("received response " + response.toString());
					
				
					// wait a bit then send another packet
					Thread.sleep(waittime);
					
					// write out result
					writeResultJSONFile(result);
				}
			}
			
			
		} catch (Exception e) {
			e.printStackTrace(); logger.error("SOME ERROR: ",e);
		} 
		finally {
//			xbee.close();
			logger.info("<----- sendIncrementData()");
		}
		return retval;
	}

	
	private static Integer readDataFromPin(XBee xbee, XBeeRequest sample)	throws XBeeException, IOException {
		Integer retval = null;
		try {
			XBeeResponse sampleresponse = xbee.sendSynchronous(sample, 6000);
			RemoteAtResponse remoteAt = (RemoteAtResponse) sampleresponse;
			
			if (remoteAt.isOk())  {
				// extract the i/o sample
				ZNetRxIoSampleResponse ioSample = ZNetRxIoSampleResponse.parseIsSample(remoteAt);
				// make sure you configured the remote XBee to D1=2 (analog input) or you will get an error
				retval = ioSample.getAnalog1();
				logger.info("10 bit analog1 sample is " + retval);
			} else {
				logger.info("Remote AT request failed: " + sampleresponse);
			}		
		} catch (XBeeTimeoutException e) {
			logger.info("request timed out");	
		}
		return retval;
	}		
	
	private static String transformStringToValid64BitXBeeAddress(String addr) {
		String retval = "";
		
		// ha hb hc hd he hf hg hh la lb lc ld le lf lg lh 
		if(addr.contains(" ") && addr.length() == 47){
			// do nothing - its already in the right format
			 retval = addr;
		} else {
			// format it to 
			// ha hb hc hd he hf hg hh la lb lc ld le lf lg lh
			if(addr.length() == 16){
				// yes every thing is ok la
				for(int i = 0; i < 16; i++){
					retval = retval + addr.charAt(i);
					if((i+1) % 2 == 0 ){
						retval = retval + " ";
					}
				}
			}
		}
		return retval;
	}
	
	
	private static void writeResultJSONFile(XBeeComandResultObject result) {
		logger.debug("---> writeResultJSONFile()");
		result.setTimestampNow();
		// 2. bring result ds into right form
		ArrayList<XBeeComandResultObject> res = new ArrayList<XBeeComandResultObject>();
		res.add(result);
		
		// 3. Prep file
		BufferedWriter  bw = prepareFile("data_result_manage_brick_network.json");
		
		// 4. serialize
		JSONSerializer serializer = new JSONSerializer().transform(new DateTransformer("yyyy-MM-dd HH:mm:ss"), Date.class); 
		String val =  serializer.exclude("*.class").serialize( res );
		
		try {
			bw.write(val);
			bw.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			logger.error("ERROR WRITING JSON FILE POS 1: ", e);

		} catch (Exception ex) {
			// TODO Auto-generated catch block
			ex.printStackTrace();
			logger.error("ERROR WRITING JSON FILE POS 2: ", ex);

		} 
		finally {
			logger.debug("<--- writeResultJSONFile()");
			
		}
	}
	
	/**
	 * Opens the file stream - with docroot and file name
	 * @param filename
	 * @return
	 */
	protected static BufferedWriter  prepareFile(String filename){
		BufferedWriter bw = null;
		if(isPresentationWarDeployed()){
			
			try {
		    	String docroot = ServerEnvironmentSingleton.getInstance().DOC_ROOT_PRESENTATION;
	
		    	logger.debug("prepareFile("+filename+") to: "+ docroot+filename);
		    	File file = new File(docroot+filename);
		
				// if file doesnt exists, then create it
				if (!file.exists()) {
						file.createNewFile();
				}
		
				FileWriter fw = new FileWriter(file.getAbsoluteFile());
				bw = new BufferedWriter(fw);
			
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace(); logger.error("ERROR WRITING FILE ["+filename+"]: ",e);
			}		
		}
		return bw;
	}	
	
	protected static boolean isPresentationWarDeployed(){
		boolean retval = false;
    	String docroot = null;
    	docroot = ServerEnvironmentSingleton.getInstance().DOC_ROOT_PRESENTATION;
		if(docroot == null ){
			logger.error("ERROR: docroot PROPERTY IS NOT CONFIGURED - IT IS NULL - CHECK FILE tmor.properties");
			throw new RuntimeException("ERROR: docroot PROPERTY IS NOT CONFIGURED - IT IS NULL - CHECK FILE tmor.properties");
		} else {
			try{
				File file = new File(docroot);
				if(file.isDirectory()){
					retval = true;
				}
			} catch (Exception ioe){
				logger.error("ERROR: APPLICATION NOT PROPERLY CONFIGURED - CHECK property docroot in FILE tmor.properties", ioe);
				throw new RuntimeException("ERROR: docroot PROPERTY IS NOT CONFIGURED - IT IS NULL - CHECK FILE tmor.properties");
			}
		}
		return retval;
	}
}

