package com.moneyhouse.sensors.xbee;

import java.io.Serializable;

import com.rapplogic.xbee.api.XBee;

public class XBeeSingleton implements Serializable {
	private static final long serialVersionUID = 116198718180630024L;
	private XBee xbee = null;
	private static XBeeSingleton instance = null;

	protected XBeeSingleton() {
		this.xbee = new XBee();
	}

	public static XBeeSingleton getInstance() {
		if (instance == null) {
			instance = new XBeeSingleton();
		}
		return instance;
	}
	public static void resetInstance() {
		instance = null;
	}
	
	public synchronized  XBee getXbee() {
		try {
			int counter = 0;
			boolean isConnected = true;
			while (isConnected) {
				if (xbee.isConnected()) {
					isConnected = true;
				} else {
					isConnected = false;
				}
				counter++;
				Thread.sleep(1000);
				if(counter > 120){
					throw new RuntimeException("ERROR: XBEE seems to be engaged by someone else - waiting since ["+counter+"] rounds XBEE IS CONNECTED = ["+isConnected+"]");
				}
			}
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return this.xbee;
	}

}
