package com.moneyhouse.sensors.xbee.dto;

import java.io.Serializable;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;


/**
 * HOLDS THE ESSENTIAL INFO OF A FILE
 * @author QQ
 *
 */
public class FileDescDataObject implements Serializable{
	private static final long serialVersionUID = -567627525190750444L;
	private String name;					// uniqueId    
	private String createdtimestamp;		// when was the file created	
	private long ts;						// it for sorting by createdtimestamp
	private String size;		    		
	
	public FileDescDataObject(){
	}

	public String toString(){
		return this.getName() +"\t"+this.getSize() +"\t"+this.getCreatedtimestamp();
	}
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getCreatedtimestamp() {
		return createdtimestamp;
	}


	public void setCreatedtimestamp(long createdtimestamp) {
		ts = createdtimestamp;
		Timestamp ts = new Timestamp(createdtimestamp);
		String s = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss").format(ts);
		this.createdtimestamp = s;
	}

	public String getSize() {
		return size;
	}

	public void setSize(String size) {
		this.size = size;
	}
	public void setSize(long size) {
		
		String res = "";
		if(size > 1024 && size > 1024*1024 ){
			long sizeoffilemb = size/(1024*1024);
			res = sizeoffilemb + " MB\t("+size+" Bytes)" ;
		} else if(size > 1024 && size < 1024*1024 ){
			long sizeoffilemb = size/(1024);
			res = sizeoffilemb + " KB\t("+size+" Bytes)" ;
		} else if(size < 1024 ){
			res = size + " Bytes" ;
		} else{
			throw new RuntimeException("ERROR: CAN NOT PROCESS THIS FILE SIZE ["+size+"] - CHECK");
		}
		this.size = res;
	}

	public long getTs() {
		return ts;
	}

	public void setTs(long ts) {
		this.ts = ts;
	}


}
