package com.moneyhouse.sensors.xbee.dto;

import java.io.File;
import java.io.Serializable;
import java.sql.Timestamp;
import java.text.DateFormat;
import java.text.SimpleDateFormat;

/** ELEMENTS FOR XBEE RECEIVING QUEUE 
 * HOLD THE FILENAME AND CREATION DATE
 * @author Frederic
 *
 */
public class ToBrickFileQueueElementDataObject implements Serializable {
	private static final long serialVersionUID = 2630967300847831082L;

	
	private File filename = null;
	private Timestamp receivedTimestamp = null;
	private String receivedTimestampStr = "";			// STRING reprensentation of receivedTimestamp
	private int readingCounter = 0;

	
	
	public ToBrickFileQueueElementDataObject(){
		this.filename = null;
		receivedTimestamp = new Timestamp(System.currentTimeMillis());
		
	}

	/** TAKES NOW AS TIMESTAMP
	 * @param filen
	 */
	public ToBrickFileQueueElementDataObject(File filen){
		this.filename = filen;
		receivedTimestamp = new Timestamp(System.currentTimeMillis());
	}	
	
	
	public File getFilename() {
		return filename;
	}

	public void setFilename(File filename) {
		this.filename = filename;
	}

	public Timestamp getReceivedTimestamp() {
		return receivedTimestamp;
	}

	public String getReceivedTimestampFormated() {
		DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss.mmm");
		String formatted = dateFormat.format(getReceivedTimestamp()) ;
		return formatted; 
	}

	
	public void setReceivedTimestamp(Timestamp receivedTimestamp) {
		this.receivedTimestamp = receivedTimestamp;
	}
	
	public String toString(){
		DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss.mmm");
		String formatted = dateFormat.format(getReceivedTimestamp()) ;
		return formatted +"\tREADING COUNTER: " + getReadingCounter() +"\t" + this.getFilename().toString();
	}

	public int getReadingCounter() {
		return readingCounter;
	}

	public void setReadingCounter(int readingCounter) {
		this.readingCounter = readingCounter;
	}
	public void incrementReadingCounter() {
		this.readingCounter++;
	}
	
	public String getReceivedTimestampStr() {
		DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss.mmm");
		this.receivedTimestampStr = dateFormat.format(getReceivedTimestamp()) ;
		return receivedTimestampStr;
	}

	public void setReceivedTimestampStr(String receivedTimestampStr) {
		DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss.mmm");
		this.receivedTimestampStr = dateFormat.format(getReceivedTimestamp()) ;
	}

	
}
