package com.moneyhouse.sensors.xbee.dto;

import java.io.Serializable;
import java.sql.Timestamp;

/**
 * TO SEND AT COMMANDS TO ONE OR ALL XBEE MODULES WITHIN THE NETWORK
 * such as ATDT 1F
 * 
 * The _ character means NULL
 * 
 * @author QQ
 *
 */
/**
 * @author QQ
 *
 */
public class XBeeComandObject implements Serializable{
	private static final long serialVersionUID = 2191663022615962087L;
	private String brickid = "_";					// BrickUniqueID or Wildcard such as *
	private String atcommand = "_";					// XBee command such as ATID
	private String atcommandparameter = "_";		// Parameter that goes with the command
	private String correlID = "";					// correlation Id to match request with response
	private Timestamp timestamp = null;				// Timestamp of command call
	
	public String getBrickid() {
		return brickid;
	}
	public void setBrickid(String brickid) {
		this.brickid = brickid;
	}
	public String getAtcommand() {
		return atcommand;
	}
	public void setAtcommand(String atcommand) {
		this.atcommand = atcommand;
	}
	public String getAtcommandparameter() {
		return atcommandparameter;
	}
	public void setAtcommandparameter(String atcommandparameter) {
		this.atcommandparameter = atcommandparameter;
	}
	public String getCorrelID() {
		return correlID;
	}
	public void setCorrelID(String correlID) {
		this.correlID = correlID;
	}
	
	
	public Timestamp getTimestamp() {
		return timestamp;
	}
	public void setTimestamp(Timestamp timestamp) {
		this.timestamp = timestamp;
	}
	public String toString()
	{
		return  this.brickid +"\t"+ this.atcommand+ "\t" + this.atcommandparameter+ "\t" + this.correlID;
	}
}
