package com.moneyhouse.sensors.xbee.thread;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;

import org.apache.log4j.Logger;

import com.moneyhouse.sensors.xbee.XBeeDataQueueSingleton;
import com.moneyhouse.sensors.xbee.dto.ToBrickErrorFileQueueElementDataObject;

/**
 * LOOPS AND FROM TIME TO TIME IT CLEANS AWAY ENTRIES FROM tHE ERROR LIST
 * @author Frederic
 * @since 29.07.2015
 *
 */
public class QueueMaintenanceThread extends Thread {
	private final static Logger logger = Logger.getLogger(QueueMaintenanceThread.class);
	private final static Logger loggerfile = Logger.getLogger("requestLogger");
	private Thread t;
	private String threadName = "QueueMaint" ;

	
	// 1. STEP
	public QueueMaintenanceThread(){
		logger.info("--> QueueMaintenanceThread()");
		logger.info("<-- QueueMaintenanceThread()");
	}
	
	// 2. STARTS
	public void start ()
	{
		logger.info("--> QueueMaintenanceThread.start()");
		System.out.println("Starting " +  threadName );
		if (t == null)
		{
			t = new Thread (this, threadName);
			t.setPriority(MIN_PRIORITY);
			t.start ();
		}
		logger.info("<-- QueueMaintenanceThread.start()");

	}
	   
	   
	// 2. RUNS
	public void run() {
		logger.info("--> QueueMaintenanceThread.run()");
//		long tsstart = System.currentTimeMillis();
		for(;;){
			// ENDLESS LOOP 
			sleeep(3 * 60 * 60 * 1000);	// 3h
			loggerfile.info("START PRINTING OUT ERROR LIST -------------------------------------------");

			XBeeDataQueueSingleton queue = XBeeDataQueueSingleton.getInstance();
			ArrayList<ToBrickErrorFileQueueElementDataObject> errorList = queue.flushToBrickError();
			for(int i = 0 ; i < errorList.size();i++){
				loggerfile.info("["+i+"]\t"+errorList.get(i));
			}
			loggerfile.info("END PRINTING OUT ERROR LIST  WITH ["+errorList.size()+"] ELEMETNS-------------------------------------------");

		}
		
		// logger.info("<-- QueueMaintenanceThread.run()");

	}
	
	
	
	private static void sleeep(long mssllep) {
		logger.info("-----> sleeep()");
		long start = System.currentTimeMillis();
			try{
				// System.out.println("["+i+"] GO SLEEP NOW" );
				Thread.sleep(mssllep);
			} catch(Exception e){
				e.printStackTrace();
			}
		long end = System.currentTimeMillis();

		BigDecimal res = new BigDecimal((end-start)).divide(new BigDecimal(1000), RoundingMode.FLOOR); 
		logger.info("<----- sleeep() \tSLEPT = ["+res+"] s");
	}

}
