/**
 * Copyright (c) 2016 Money House Limited Qian Zhuang 88 All rights reserved.
 *  
 * This file is part of TMOR system, is free software and comes with no WARRANTY
 *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM, 
 * TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING 
 * THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY 
 * OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK 
 * AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE 
 * DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. 
 * 
 * This program is free software; you can redistribute it and/or modify it under the 
 * terms of the GNU General Public License as published by the Free Software Foundation; 
 * version 3 of the License, or (at your option) any later version. 
 * 
 * TMOR is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 * PURPOSE. See the GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License along with TMOR.  
 * If not, see <http://www.gnu.org/licenses/>.
 */
package com.moneyhouse.tmor.serial.internal.idgenerator;

public class BRICKUNIQUEIDHELPER {

	
	 
	static public int calculateBrickUIDCheckSum(String brickid){
		int checksum = 0;
		System.out.println("--> BRICKUNIQUEIDHELPER.calculateBrickUIDCheckSum("+brickid+")");
		int checknumber = 0;
		for(int i = 0; i < brickid.length(); i++){
			String pos = brickid.substring(i, (i+1));
			if(i < 11|| i== 13 || i==15){
				try
				{
				int val= new Integer(pos).intValue();
				checknumber = checknumber + val;
				} catch (NumberFormatException ex){
					ex.printStackTrace();
					 break;
				}
			}
			if(i == 11){
				// check port ID in detail
				if(pos.equals("Z")) {
					checknumber = checknumber + 3; 
				}
				else if (pos.equals("A")) {
					checknumber = checknumber + 1; 
				}
				else if (pos.equals("B")) {
					checknumber = checknumber + 2; 
				}
				else {
					break;
					
				}
			}
			else if(i == 12){
				// expect a M
				if(pos.equals("M")) {
					checknumber = checknumber + 14; 
				} else{
					break;
				}
			}
			else if(i == 14){
				// expect a _
				if(pos.equals("_")) {
					checknumber = checknumber + 5; 
				} else{
					break;
				}
			}
			
			
		}
		String calcres = checknumber+"";
		int le = calcres.length();
		String lastDigit = calcres.substring((le-1));
		checksum = new Integer(lastDigit).intValue();

		System.out.println("<-- BRICKUNIQUEIDHELPER.calculateBrickUIDCheckSum("+brickid+")");
		return checksum;
	} 
	
	static public boolean isBrickUIDParameterValid(String para){
		System.out.println("--> BRICKUNIQUEIDHELPER.isBrickUIDParameterValid("+para+")");
		boolean retval = true; 
		int checknumber = 0;
		for(int i = 0; i < para.length(); i++){
			String pos = para.substring(i, (i+1));
			if(i < 11|| i== 13 || i==15){
				try
				{
				int val= new Integer(pos).intValue();
				checknumber = checknumber + val;
				} catch (NumberFormatException ex){
					ex.printStackTrace();
					 retval = false;
					 break;
				}
			}
			if(i == 11){
				// check port ID in detail
				if(pos.equals("Z")) {
					checknumber = checknumber + 3; 
				}
				else if (pos.equals("A")) {
					checknumber = checknumber + 1; 
				}
				else if (pos.equals("B")) {
					checknumber = checknumber + 2; 
				}
				else {
					retval = false;
					break;
					
				}
			}
			else if(i == 12){
				// expect a M
				if(pos.equals("M")) {
					checknumber = checknumber + 14; 
				} else{
					retval = false;
					break;
				}
			}
			else if(i == 14){
				// expect a _
				if(pos.equals("_")) {
					checknumber = checknumber + 5; 
				} else{
					retval = false;
					break;
				}
			}
			
			else if(i == 16){
				// ultimate check - compare check id with calucualted result
				String calcres = checknumber+"";
				int le = calcres.length();
				String lastDigit = calcres.substring((le-1));
				System.out.println("Expected: "+lastDigit);
				System.out.println("Obtained: "+pos);
				if(lastDigit.equals(pos)){
					// its the same
					// correct 
				} else{
					retval = false;
					break;
					
				}
			}
			
		}
		System.out.println("<-- BRICKUNIQUEIDHELPER.isBrickUIDParameterValid("+para+")");
		
		return retval;
	}
}
