/**
 * Copyright (c) 2016 Money House Limited Qian Zhuang 88 All rights reserved.
 *  
 * This file is part of TMOR system, is free software and comes with no WARRANTY
 *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM, 
 * TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING 
 * THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY 
 * OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK 
 * AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE 
 * DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. 
 * 
 * This program is free software; you can redistribute it and/or modify it under the 
 * terms of the GNU General Public License as published by the Free Software Foundation; 
 * version 3 of the License, or (at your option) any later version. 
 * 
 * TMOR is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 * PURPOSE. See the GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License along with TMOR.  
 * If not, see <http://www.gnu.org/licenses/>.
 */
package com.moneyhouse.tmor.serial.json;

import java.io.Serializable;

/**
 * @author Frederic
 * @since 3.11.2014
 * 
 * Data structure should look like this:
 * [{"fromaddress":"n/a","correlid":"33333","timestamp":"n/a","executiontime":"n/a"}]
 * {"correlid":"MnZYZeGr","executiontime":"1896","fromaddress":"0x00,0x13,0xa2,0x00,0x40,0x0a,0x4a,0x0a","timestamp":"2014-11-03 16:38:34.139"}
 * 
 */
public class JSONPingAnswer extends JSONAbstract implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -7399374489654393736L;
	private String executiontime = "";
	
	public JSONPingAnswer(){
	}

	public JSONPingAnswer(String fromaddress, String correlid, String timestamp, String executiontime){
		this.setFromaddress(fromaddress) ;
		this.setCorrelid(correlid) ;
		this.setTimestamp(timestamp);
		this.executiontime = executiontime;
		
	}

	

	public String getExecutiontime() {
		return executiontime;
	}

	public void setExecutiontime(String executiontime) {
		this.executiontime = executiontime;
	}
}