/**
 * Copyright (c) 2016 Money House Limited Qian Zhuang 88 All rights reserved.
 *  
 * This file is part of TMOR system, is free software and comes with no WARRANTY
 *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM, 
 * TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING 
 * THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY 
 * OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK 
 * AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE 
 * DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. 
 * 
 * This program is free software; you can redistribute it and/or modify it under the 
 * terms of the GNU General Public License as published by the Free Software Foundation; 
 * version 3 of the License, or (at your option) any later version. 
 * 
 * TMOR is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 * PURPOSE. See the GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License along with TMOR.  
 * If not, see <http://www.gnu.org/licenses/>.
 */
package com.moneyhouse.tmor.serial.pi.dto;

import java.io.Serializable;
import java.math.BigDecimal;
import java.sql.Timestamp;

/**
 * Holds the result of a one wire sensor connected to the PI / basis station
 * @author Frederic
 * @since 13.07.2015
 */
public class DSSensorResultDTO implements Serializable{
	private static final long serialVersionUID = 8807498681241308985L;

	private String sensorID = "";

	private String readingValueStr = "";
	private BigDecimal readingValueBD = null;
	private String crcValue = "";
	private boolean readingValueValid = false;
	private Timestamp readingtime  = null;
	
	
	public DSSensorResultDTO(){}
	

	/**
	 * fill in the BigDecimal Value, and sets the valid value to true
	 * @param readingValue
	 */
	public DSSensorResultDTO(String readingValue){
		readingValueStr = readingValue;
		readingValueBD = new BigDecimal(readingValue);
		readingValueValid = true;
	}

	
	public String toString(){
		return this.readingValueStr +"\t" + this.readingValueValid+"\t" + this.readingValueBD;
	}

	public String getSensorID() {
		return sensorID;
	}


	public void setSensorID(String sensorID) {
		this.sensorID = sensorID;
	}


	public String getReadingValueStr() {
		return readingValueStr;
	}


	public void setReadingValueStr(String readingValueStr) {
		this.readingValueStr = readingValueStr;
	}


	public BigDecimal getReadingValueBD() {
		return readingValueBD;
	}


	public void setReadingValueBD(BigDecimal readingValueBD) {
		this.readingValueBD = readingValueBD;
	}


	public String getCrcValue() {
		return crcValue;
	}


	public void setCrcValue(String crcValue) {
		this.crcValue = crcValue;
	}


	public boolean isReadingValueValid() {
		return readingValueValid;
	}


	public void setReadingValueValid(boolean readingValueValid) {
		this.readingValueValid = readingValueValid;
	}


	public Timestamp getReadingtime() {
		return readingtime;
	}


	public void setReadingtime(Timestamp readingtime) {
		this.readingtime = readingtime;
	}

	
	
	
	
}
