/**
 * Copyright (c) 2016 Money House Limited Qian Zhuang 88 All rights reserved.
 *  
 * This file is part of TMOR system, is free software and comes with no WARRANTY
 *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM, 
 * TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING 
 * THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY 
 * OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK 
 * AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE 
 * DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. 
 * 
 * This program is free software; you can redistribute it and/or modify it under the 
 * terms of the GNU General Public License as published by the Free Software Foundation; 
 * version 3 of the License, or (at your option) any later version. 
 * 
 * TMOR is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 * PURPOSE. See the GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License along with TMOR.  
 * If not, see <http://www.gnu.org/licenses/>.
 */
package com.moneyhouse.tmor.serial.xbee;

import java.io.Serializable;

import com.rapplogic.xbee.api.XBee;

public class XBeeSingleton implements Serializable {
	private static final long serialVersionUID = 116198718180630024L;
	private XBee xbee = null;
	private static XBeeSingleton instance = null;

	protected XBeeSingleton() {
		this.xbee = new XBee();
	}

	public static XBeeSingleton getInstance() {
		if (instance == null) {
			instance = new XBeeSingleton();
		}
		return instance;
	}
	public static void resetInstance() {
		instance = null;
	}
	
	public synchronized  XBee getXbee() {
		try {
			int counter = 0;
			boolean isConnected = true;
			while (isConnected) {
				if (xbee.isConnected()) {
					isConnected = true;
				} else {
					isConnected = false;
				}
				counter++;
				Thread.sleep(1000);
				if(counter > 120){
					throw new RuntimeException("ERROR: XBEE seems to be engaged by someone else - waiting since ["+counter+"] rounds XBEE IS CONNECTED = ["+isConnected+"]");
				}
			}
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return this.xbee;
	}

}
