/**
 * Copyright (c) 2016 Money House Limited Qian Zhuang 88 All rights reserved.
 *  
 * This file is part of TMOR system, is free software and comes with no WARRANTY
 *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM, 
 * TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING 
 * THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY 
 * OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK 
 * AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE 
 * DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. 
 * 
 * This program is free software; you can redistribute it and/or modify it under the 
 * terms of the GNU General Public License as published by the Free Software Foundation; 
 * version 3 of the License, or (at your option) any later version. 
 * 
 * TMOR is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 * PURPOSE. See the GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License along with TMOR.  
 * If not, see <http://www.gnu.org/licenses/>.
 */
package com.moneyhouse.tmor.serial.xbee.dto;

import java.io.Serializable;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;


/**
 * HOLDS THE ESSENTIAL INFO OF A FILE
 * @author QQ
 *
 */
public class FileDescDataObject implements Serializable{
	private static final long serialVersionUID = -567627525190750444L;
	private String name;					// uniqueId    
	private String createdtimestamp;		// when was the file created	
	private long ts;						// it for sorting by createdtimestamp
	private String size;		    		
	
	public FileDescDataObject(){
	}

	public String toString(){
		return this.getName() +"\t"+this.getSize() +"\t"+this.getCreatedtimestamp();
	}
	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getCreatedtimestamp() {
		return createdtimestamp;
	}


	public void setCreatedtimestamp(long createdtimestamp) {
		ts = createdtimestamp;
		Timestamp ts = new Timestamp(createdtimestamp);
		String s = new SimpleDateFormat("dd/MM/yyyy HH:mm:ss").format(ts);
		this.createdtimestamp = s;
	}

	public String getSize() {
		return size;
	}

	public void setSize(String size) {
		this.size = size;
	}
	public void setSize(long size) {
		
		String res = "";
		if(size > 1024 && size > 1024*1024 ){
			long sizeoffilemb = size/(1024*1024);
			res = sizeoffilemb + " MB\t("+size+" Bytes)" ;
		} else if(size > 1024 && size < 1024*1024 ){
			long sizeoffilemb = size/(1024);
			res = sizeoffilemb + " KB\t("+size+" Bytes)" ;
		} else if(size < 1024 ){
			res = size + " Bytes" ;
		} else{
			throw new RuntimeException("ERROR: CAN NOT PROCESS THIS FILE SIZE ["+size+"] - CHECK");
		}
		this.size = res;
	}

	public long getTs() {
		return ts;
	}

	public void setTs(long ts) {
		this.ts = ts;
	}


}
