/**
 * Copyright (c) 2016 Money House Limited Qian Zhuang 88 All rights reserved.
 *  
 * This file is part of TMOR system, is free software and comes with no WARRANTY
 *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM, 
 * TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING 
 * THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY 
 * OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK 
 * AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE 
 * DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. 
 * 
 * This program is free software; you can redistribute it and/or modify it under the 
 * terms of the GNU General Public License as published by the Free Software Foundation; 
 * version 3 of the License, or (at your option) any later version. 
 * 
 * TMOR is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 * PURPOSE. See the GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License along with TMOR.  
 * If not, see <http://www.gnu.org/licenses/>.
 */
package com.moneyhouse.tmor.serial.xbee.dto;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.HashMap;

/**
 * TO SEND AT COMMANDS TO ONE OR ALL XBEE MODULES WITHIN THE NETWORK
 * such as ATDT 1F
 * 
 * The _ character means NULL
 * 
 * @author QQ
 *
 */
/**
 * @author QQ
 *
 */
public class XBeeComandObject implements Serializable{
	private static final long serialVersionUID = 2191663022615962087L;
	private String brickid = "_";											// BrickUniqueID or Wildcard such as *
	private String atcommand = "_";											// XBee command such as ATID
	private String atcommandparameter = "_";								// Parameter that goes with the command
	private String correlID = "";											// correlation Id to match request with response
	private Timestamp timestamp = null;										// Timestamp of command call
	private HashMap<String, String> additionalParamters = new HashMap();	// ADDED FOR ADDITIONAL PARAMTERS SUCH AS WRITE RULE
	
	
	
	public void storeAdditionalParameter(String key, String value){
		additionalParamters.put(key, value);
	}
	
	public String getAdditionalParameter(String key){
		return additionalParamters.get(key);
	}
	
	
	public String getBrickid() {
		return brickid;
	}
	public void setBrickid(String brickid) {
		this.brickid = brickid;
	}
	public String getAtcommand() {
		return atcommand;
	}
	public void setAtcommand(String atcommand) {
		this.atcommand = atcommand;
	}
	public String getAtcommandparameter() {
		return atcommandparameter;
	}
	public void setAtcommandparameter(String atcommandparameter) {
		this.atcommandparameter = atcommandparameter;
	}
	public String getCorrelID() {
		return correlID;
	}
	public void setCorrelID(String correlID) {
		this.correlID = correlID;
	}
	
	
	public Timestamp getTimestamp() {
		return timestamp;
	}
	public void setTimestamp(Timestamp timestamp) {
		this.timestamp = timestamp;
	}
	public String toString()
	{
		return  this.brickid +"\t"+ this.atcommand+ "\t" + this.atcommandparameter+ "\t" + this.correlID;
	}
}
