/**
 * Copyright (c) 2016 Money House Limited Qian Zhuang 88 All rights reserved.
 *  
 * This file is part of TMOR system, is free software and comes with no WARRANTY
 *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM, 
 * TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING 
 * THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY 
 * OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK 
 * AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE 
 * DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. 
 * 
 * This program is free software; you can redistribute it and/or modify it under the 
 * terms of the GNU General Public License as published by the Free Software Foundation; 
 * version 3 of the License, or (at your option) any later version. 
 * 
 * TMOR is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 * PURPOSE. See the GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License along with TMOR.  
 * If not, see <http://www.gnu.org/licenses/>.
 */
package com.moneyhouse.tmor.serial.xbee.dto.test;

import java.util.Vector;

import com.moneyhouse.tmor.serial.internal.idgenerator.IDGenerator;
import com.moneyhouse.tmor.serial.xbee.dto.XBeeDataTransportObject;

public class TestXBeeDataTransportObject {

    // create some TestXBeeDataTransportObject object
	// check the uniqueness of datagram
	public static void main(String[] args) {  
    
	    XBeeDataTransportObject datagram1 = new XBeeDataTransportObject("70000000030AM1_45", "HALL", "FeWR_nN5", "2013-05-13 11:58:23.474");
	    XBeeDataTransportObject datagram2 = new XBeeDataTransportObject("70000000030BM1_46", "HALL", "UPkUtut4", "2013-05-13 11:58:11.871");
	    XBeeDataTransportObject datagram3 = new XBeeDataTransportObject("70000000030BM1_46", "HALL", "MRYiwsYr", "2013-05-13 11:58:11.871");
	    XBeeDataTransportObject datagram4 = new XBeeDataTransportObject("90000000030AM1_47", "HALL", "lJzsiOaJ", "2013-05-13 11:55:47.755");
	    
	    String datagram1str = datagram1.generateDataGram();
	    String datagram2str = datagram2.generateDataGram();
	    String datagram3str = datagram3.generateDataGram();
	    String datagram4str = datagram4.generateDataGram();
	    
	    System.out.println(datagram1str.length() + "\t" + datagram1str);
	    System.out.println(datagram2str.length() + "\t" + datagram2str);
	    System.out.println(datagram3str.length() + "\t" + datagram3str);
	    System.out.println(datagram4str.length() + "\t" + datagram4str);
	    
	    Vector<XBeeDataTransportObject> data= new Vector<XBeeDataTransportObject>();
	    int sic = 1000000;
	    for(int i = 0 ; i < sic; i++){
	    	String id = new IDGenerator().getNewID().substring(0, 17);	// "70000000030AM1_45"
//	    	String type = new IDGenerator().getNewID().substring(0, 4);	// "HALL"
	    	String correl = new IDGenerator().createCorrelationID();	// "FeWR_nN5"
	    	XBeeDataTransportObject datagram = new XBeeDataTransportObject(id, "HALL", correl, "2013-05-13 11:58:23.474");
	    	data.add(datagram);
	    }
	    
	    for(int i = 0 ; i < sic; i++){
	    	System.out.println(data.elementAt(i).generateDataGram().length() + "\t"+ data.elementAt(i).generateDataGram());
	    }
	    int maxcounter = 0;
	    long occur = 0;
	    for(int i = 0 ; i < sic; i++){
	    	System.out.println(data.elementAt(i).generateDataGram().length() + "\t"+ data.elementAt(i).generateDataGram());
	    	String checksumi = data.elementAt(i).getChecksum();
		    int counter = 0;
	    	for(int j = i+1 ; j < sic-1; j++){
		    	String checksumj = data.elementAt(j).getChecksum();
		    	if(checksumj.equals(checksumi)){
		    		counter++;
		    		occur++;
		    		if(maxcounter < counter){
		    			maxcounter = counter;
		    		}
		    	}
		    }
	    	System.out.println("DOUBLE CHECKSUM COUNTER "+ counter + "\t\tMAXCOUNT = "+maxcounter+ "\t\tOCCURENCES = "+occur);
	    
	    }
	    
	 }
	
	
}
