package com.moneyhouse.tmor.serial.xbee.flag;

import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.apache.log4j.Logger;

public class XBeeStatusLineDTO {
	private Timestamp time = null;
	private String timeStr = "";
	private boolean isSuccessConnect = false;
	private final static Logger logger = Logger.getLogger(XBeeStatusLineDTO.class);
	/**
	 * OBJ TO HOLD DATA ROW OF xbee_status_log
	 * @since 2017.06.26
	 */
	public XBeeStatusLineDTO(){
		
	}
	
	public XBeeStatusLineDTO(String wholeLine){
//		logger.info("-----> XBeeStatusLineDTO.XBeeStatusLineDTO("+wholeLine+")");
		String[] parts = wholeLine.split("\t");

		if(parts.length == 2){
			String time = parts[0]; 
			String status = parts[1]; 
			
			this.timeStr = time;
			try{
			    SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss.SSS");
			    Date parsedDate = dateFormat.parse(time);
			    Timestamp timestamp = new java.sql.Timestamp(parsedDate.getTime());
			    this.time = timestamp;
			}catch(Exception e){
				throw new RuntimeException("ERROR: READING XBEE STATUS LOG FILE - ENTRY ["+wholeLine+"] WITH PART ["+time+"] CAN NOT BE PARSED TO TIMESTAP");
			}
			
			if(status.contains("FAILED")){
				this.isSuccessConnect = false;
			} else if(status.contains("CONNECTED")){
				this.isSuccessConnect = true;
			}
		} else {
			if(wholeLine.length() > 43){
				// IGNORE - ITS THE HEADER OF THE LOG FILE
//				logger.info("IGNORE ["+wholeLine+"] - ITS THE HEADER OF THE LOG FILE");
			} else {
				// the line must have two elements - divided by a tab
				logger.error("ERROR: READING XBEE STATUS LOG FILE - ENTRY ["+wholeLine+"] DOES NOT HAVE 2 ELEMENTS");
				throw new RuntimeException("ERROR: READING XBEE STATUS LOG FILE - ENTRY ["+wholeLine+"] DOES NOT HAVE 2 ELEMENTS");
			}
		}
//		logger.info("<----- XBeeStatusLineDTO.XBeeStatusLineDTO("+wholeLine+")");
	}
	
	
	public Timestamp getTime() {
		if(this.time == null){
			try{
			    SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss.SSS");
			    Date parsedDate = dateFormat.parse(this.timeStr);
			    Timestamp timestamp = new java.sql.Timestamp(parsedDate.getTime());
			    this.time = timestamp;
			}catch(Exception e){
				System.out.println("ERROR: CANT CONVERT TIME STR ["+this.timeStr+"] TO TIMESTAMP OBJ");
			}
		}
		return time;
	}
	public void setTime(Timestamp time) {
		this.time = time;
	}
	public String getTimeStr() {
		return timeStr;
	}
	public void setTimeStr(String timeStr) {
		this.timeStr = timeStr;
	}
	public boolean isSuccessConnect() {
		return isSuccessConnect;
	}
	public void setSuccessConnect(boolean isSuccessConnect) {
		this.isSuccessConnect = isSuccessConnect;
	}
	
	public String toString(){
		return this.time +"\t" + this.isSuccessConnect;
	}
}
