/**
 * Copyright (c) 2016 Money House Limited Qian Zhuang 88 All rights reserved.
 *  
 * This file is part of TMOR system, is free software and comes with no WARRANTY
 *
 * BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM, 
 * TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING 
 * THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY 
 * OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED 
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK 
 * AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE 
 * DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION. 
 * 
 * This program is free software; you can redistribute it and/or modify it under the 
 * terms of the GNU General Public License as published by the Free Software Foundation; 
 * version 3 of the License, or (at your option) any later version. 
 * 
 * TMOR is distributed in the hope that it will be useful,but WITHOUT ANY WARRANTY; 
 * without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
 * PURPOSE. See the GNU General Public License for more details.
 *  
 * You should have received a copy of the GNU General Public License along with TMOR.  
 * If not, see <http://www.gnu.org/licenses/>.
 */
package com.moneyhouse.tmor.serial.xbee.thread;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;

import org.apache.log4j.Logger;

import com.moneyhouse.tmor.serial.xbee.XBeeDataQueueSingleton;
import com.moneyhouse.tmor.serial.xbee.dto.ToBrickErrorFileQueueElementDataObject;

/**
 * LOOPS AND FROM TIME TO TIME IT CLEANS AWAY ENTRIES FROM tHE ERROR LIST
 * @author Frederic
 * @since 29.07.2015
 *
 */
public class QueueMaintenanceThread extends Thread {
	private final static Logger logger = Logger.getLogger(QueueMaintenanceThread.class);
	private final static Logger loggerfile = Logger.getLogger("requestLogger");
	private Thread t;
	private String threadName = "QueueMaint" ;

	
	// 1. STEP
	public QueueMaintenanceThread(){
		logger.info("--> QueueMaintenanceThread()");
		logger.info("<-- QueueMaintenanceThread()");
	}
	
	// 2. STARTS
	public void start ()
	{
		logger.info("--> QueueMaintenanceThread.start()");
		System.out.println("Starting " +  threadName );
		if (t == null)
		{
			t = new Thread (this, threadName);
			t.setPriority(MIN_PRIORITY);
			t.start ();
		}
		logger.info("<-- QueueMaintenanceThread.start()");

	}
	   
	   
	// 2. RUNS
	public void run() {
		logger.info("--> QueueMaintenanceThread.run()");
//		long tsstart = System.currentTimeMillis();
		for(;;){
			// ENDLESS LOOP 
			sleeep(3 * 60 * 60 * 1000);	// 3h
			loggerfile.info("START PRINTING OUT ERROR LIST -------------------------------------------");

			XBeeDataQueueSingleton queue = XBeeDataQueueSingleton.getInstance();
			ArrayList<ToBrickErrorFileQueueElementDataObject> errorList = queue.flushToBrickError();
			for(int i = 0 ; i < errorList.size();i++){
				loggerfile.info("["+i+"]\t"+errorList.get(i));
			}
			loggerfile.info("END PRINTING OUT ERROR LIST  WITH ["+errorList.size()+"] ELEMETNS-------------------------------------------");

		}
		
		// logger.info("<-- QueueMaintenanceThread.run()");

	}
	
	
	
	private static void sleeep(long mssllep) {
		logger.info("-----> sleeep()");
		long start = System.currentTimeMillis();
			try{
				// System.out.println("["+i+"] GO SLEEP NOW" );
				Thread.sleep(mssllep);
			} catch(Exception e){
				e.printStackTrace();
			}
		long end = System.currentTimeMillis();

		BigDecimal res = new BigDecimal((end-start)).divide(new BigDecimal(1000), RoundingMode.FLOOR); 
		logger.info("<----- sleeep() \tSLEPT = ["+res+"] s");
	}

}
